Index: branches/GP-Refactoring-713/sources/HeuristicLab.GP.StructureIdentification/3.3/VariableFunctionTree.cs
===================================================================
--- branches/GP-Refactoring-713/sources/HeuristicLab.GP.StructureIdentification/3.3/VariableFunctionTree.cs	(revision 2210)
+++ branches/GP-Refactoring-713/sources/HeuristicLab.GP.StructureIdentification/3.3/VariableFunctionTree.cs	(revision 2210)
@@ -0,0 +1,98 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Text;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.GP.Interfaces;
+
+namespace HeuristicLab.GP.StructureIdentification {
+  public class VariableFunctionTree : FunctionTreeBase {
+    public double Weight { get; set; }
+    public string VariableName { get; set; }
+    public int SampleOffset { get; set; }
+
+    public VariableFunctionTree(Variable variable)
+      : base(variable) {
+    }
+
+    protected VariableFunctionTree(VariableFunctionTree original)
+      : base(original) {
+      Weight = original.Weight;
+      VariableName = original.VariableName;
+      SampleOffset = original.SampleOffset;
+    }
+
+    public override bool HasLocalParameters {
+      get {
+        return true;
+      }
+    }
+
+    public override IOperation CreateShakingOperation(IScope scope) {
+      Scope myVariableScope = new Scope();
+      scope.AddSubScope(myVariableScope);
+      myVariableScope.AddVariable(CreateWeightVariable());
+      myVariableScope.AddVariable(CreateVariableNameVariable());
+      myVariableScope.AddVariable(CreateSampleOffsetVariable());
+      return new AtomicOperation(Function.Manipulator, myVariableScope);
+    }
+
+    public override IOperation CreateInitOperation(IScope scope) {
+      Scope myVariableScope = new Scope();
+      scope.AddSubScope(myVariableScope); 
+      myVariableScope.AddVariable(CreateWeightVariable());
+      myVariableScope.AddVariable(CreateVariableNameVariable());
+      myVariableScope.AddVariable(CreateSampleOffsetVariable());
+      return new AtomicOperation(Function.Initializer, myVariableScope);
+    }
+
+    public override IFunctionTree Clone() {
+      return new VariableFunctionTree(this);
+    }
+
+    private IVariable CreateSampleOffsetVariable() {
+      IntData data = new IntData(SampleOffset);
+      data.Changed += (sender, args) => SampleOffset = data.Data;
+      var variable = new HeuristicLab.Core.Variable(Variable.OFFSET, data);
+      variable.ValueChanged += (sender, args) => SampleOffset = ((IntData)variable.Value).Data;
+      return variable;
+    }
+
+    private IVariable CreateVariableNameVariable() {
+      StringData data = new StringData(VariableName);
+      data.Changed += (sender, args) => VariableName = data.Data;
+      var variable = new HeuristicLab.Core.Variable(Variable.VARIABLENAME, data);
+      variable.ValueChanged += (sender, args) => VariableName = ((StringData)variable.Value).Data;
+      return variable;
+    }
+
+    private IVariable CreateWeightVariable() {
+      DoubleData data = new DoubleData(Weight);
+      data.Changed += (sender, args) => Weight = data.Data;
+      var variable = new HeuristicLab.Core.Variable(Variable.WEIGHT, data);
+      variable.ValueChanged += (sender, args) => Weight = ((DoubleData)variable.Value).Data;
+      return variable;
+    }
+  }
+}
Index: branches/GP-Refactoring-713/sources/HeuristicLab.GP/3.3/BaseClasses/BakedFunctionTree.cs
===================================================================
--- branches/GP-Refactoring-713/sources/HeuristicLab.GP/3.3/BaseClasses/BakedFunctionTree.cs	(revision 2210)
+++ branches/GP-Refactoring-713/sources/HeuristicLab.GP/3.3/BaseClasses/BakedFunctionTree.cs	(revision 2210)
@@ -0,0 +1,368 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using System.Xml;
+using System.Globalization;
+
+namespace HeuristicLab.GP {
+
+  public class LightWeightFunction {
+    public byte arity = 0;
+    public IFunction functionType;
+    public List<IVariable> localData = new List<IVariable>();
+
+    public LightWeightFunction Clone() {
+      LightWeightFunction clone = new LightWeightFunction();
+      clone.arity = arity;
+      clone.functionType = functionType;
+      clone.localData = localData.Select(v=>(IVariable)v.Clone()).ToList();
+      return clone;
+    }
+  }
+
+  public class BakedFunctionTree : ItemBase, IFunctionTree {
+    private List<LightWeightFunction> linearRepresentation;
+    public List<LightWeightFunction> LinearRepresentation {
+      get {
+        FlattenVariables();
+        FlattenTrees();
+        return linearRepresentation;
+      }
+    }
+    private bool treesExpanded = false;
+    private List<IFunctionTree> subTrees;
+    private bool variablesExpanded = false;
+    private List<IVariable> variables = new List<IVariable>();
+
+    public IOperator Initializer {
+      get { return Function.Initializer; }
+    }
+
+    public IOperator Manipulator {
+      get { return Function.Manipulator; }
+    }
+
+    public BakedFunctionTree() {
+      linearRepresentation = new List<LightWeightFunction>();
+    }
+
+    public BakedFunctionTree(IFunction function)
+      : this() {
+      LightWeightFunction fun = new LightWeightFunction();
+      fun.functionType = function;
+      linearRepresentation.Add(fun);
+      treesExpanded = true;
+      subTrees = new List<IFunctionTree>();
+      variables = new List<IVariable>();
+      variablesExpanded = true;
+    }
+
+    //internal BakedFunctionTree(IFunctionTree tree)
+    //  : this() {
+    //  LightWeightFunction fun = new LightWeightFunction();
+    //  fun.functionType = tree.Function;
+    //  linearRepresentation.Add(fun);
+    //  foreach (IVariable variable in tree.LocalVariables) {
+    //    IObjectData value = (IObjectData)variable.Value;
+    //    fun.localData.Add(value.Data);
+    //  }
+    //  foreach (IFunctionTree subTree in tree.SubTrees) {
+    //    AddSubTree(new BakedFunctionTree(subTree));
+    //  }
+    //}
+
+    private int BranchLength(int branchRoot) {
+      int arity = linearRepresentation[branchRoot].arity;
+      int length = 1;
+      for (int i = 0; i < arity; i++) {
+        length += BranchLength(branchRoot + length);
+      }
+      return length;
+    }
+
+    private void FlattenTrees() {
+      if (treesExpanded) {
+        linearRepresentation[0].arity = (byte)subTrees.Count;
+        foreach (BakedFunctionTree subTree in subTrees) {
+          subTree.FlattenVariables();
+          subTree.FlattenTrees();
+          linearRepresentation.AddRange(subTree.linearRepresentation);
+        }
+        treesExpanded = false;
+        subTrees = null;
+      }
+    }
+
+    private void FlattenVariables() {
+      if (variablesExpanded) {
+        linearRepresentation[0].localData.Clear();
+        foreach (IVariable variable in variables) {
+          //object objData = variable.Value;
+          //while (objData is IObjectData) objData = ((IObjectData)objData).Data;
+          //linearRepresentation[0].localData[variable.Name] = objData;
+          linearRepresentation[0].localData.Add(variable);
+        }
+        variablesExpanded = false;
+        variables = null;
+      }
+    }
+
+    public int Size {
+      get {
+        if (treesExpanded) {
+          int size = 1;
+          foreach (BakedFunctionTree tree in subTrees) {
+            size += tree.Size;
+          }
+          return size;
+        } else
+          return linearRepresentation.Count;
+      }
+    }
+
+    public int Height {
+      get {
+        if (treesExpanded) {
+          int height = 0;
+          foreach (IFunctionTree subTree in subTrees) {
+            int curHeight = subTree.Height;
+            if (curHeight > height) height = curHeight;
+          }
+          return height + 1;
+        } else {
+          int nextBranchStart;
+          return BranchHeight(0, out nextBranchStart);
+        }
+      }
+    }
+
+    private int BranchHeight(int branchStart, out int nextBranchStart) {
+      LightWeightFunction f = linearRepresentation[branchStart];
+      int height = 0;
+      branchStart++;
+      for (int i = 0; i < f.arity; i++) {
+        int curHeight = BranchHeight(branchStart, out nextBranchStart);
+        if (curHeight > height) height = curHeight;
+        branchStart = nextBranchStart;
+      }
+      nextBranchStart = branchStart;
+      return height + 1;
+    }
+
+    public IList<IFunctionTree> SubTrees {
+      get {
+        if (!treesExpanded) {
+          subTrees = new List<IFunctionTree>();
+          int arity = linearRepresentation[0].arity;
+          int branchIndex = 1;
+          for (int i = 0; i < arity; i++) {
+            BakedFunctionTree subTree = new BakedFunctionTree();
+            int length = BranchLength(branchIndex);
+            for (int j = branchIndex; j < branchIndex + length; j++) {
+              subTree.linearRepresentation.Add(linearRepresentation[j]);
+            }
+            branchIndex += length;
+            subTrees.Add(subTree);
+          }
+          treesExpanded = true;
+          linearRepresentation.RemoveRange(1, linearRepresentation.Count - 1);
+          linearRepresentation[0].arity = 0;
+        }
+        return subTrees;
+      }
+    }
+
+    public ICollection<IVariable> LocalVariables {
+      get {
+        if (!variablesExpanded) {
+          variables = new List<IVariable>();
+          IFunction function = Function;          
+          //int localVariableIndex = 0;
+          foreach (IVariable v in linearRepresentation[0].localData) {
+            //IObjectData objData = (IObjectData)clone.Value;
+            //if (objData is ConstrainedDoubleData) {
+            //  ((ConstrainedDoubleData)objData).Data = (double)linearRepresentation[0].localData[localVariableIndex];
+            //} else if (objData is ConstrainedIntData) {
+            //  ((ConstrainedIntData)objData).Data = (int)linearRepresentation[0].localData[localVariableIndex];
+            //} else {
+            //  objData.Data = linearRepresentation[0].localData[localVariableIndex];
+            //}
+            variables.Add(v);
+            //localVariableIndex++;
+          }
+          variablesExpanded = true;
+          linearRepresentation[0].localData.Clear();
+        }
+        return variables;
+      }
+    }
+
+    public IFunction Function {
+      get { return linearRepresentation[0].functionType; }
+    }
+
+    public IVariable GetLocalVariable(string name) {
+      foreach (IVariable var in LocalVariables) {
+        if (var.Name == name) return var;
+      }
+      return null;
+    }
+
+    public void AddVariable(IVariable variable) {
+      if (!variablesExpanded) throw new InvalidOperationException();
+      if (!variables.Exists(v => v.Name == variable.Name))
+        variables.Add(variable);
+    }
+
+    public void RemoveVariable(string name) {
+      if (!variablesExpanded) throw new InvalidOperationException();
+      variables.RemoveAll(v => v.Name == name);
+    }
+
+    public void AddSubTree(IFunctionTree tree) {
+      if (!treesExpanded) throw new InvalidOperationException();
+      subTrees.Add(tree);
+    }
+
+    public void InsertSubTree(int index, IFunctionTree tree) {
+      if (!treesExpanded) throw new InvalidOperationException();
+      subTrees.Insert(index, tree);
+    }
+
+    public void RemoveSubTree(int index) {
+      // sanity check
+      if (!treesExpanded) throw new InvalidOperationException();
+      subTrees.RemoveAt(index);
+    }
+
+    //public override XmlNode GetXmlNode(string name, XmlDocument document, IDictionary<Guid, IStorable> persistedObjects) {
+    //  FlattenVariables();
+    //  FlattenTrees();
+    //  XmlNode node = base.GetXmlNode(name, document, persistedObjects);
+    //  XmlNode linearRepresentationNode = document.CreateElement("LinearRepresentation");
+    //  foreach (LightWeightFunction f in linearRepresentation) {
+    //    XmlNode entryNode = PersistenceManager.Persist("Function", f.functionType, document, persistedObjects);
+    //    XmlAttribute arityAttribute = document.CreateAttribute("Arity");
+    //    arityAttribute.Value = XmlConvert.ToString(f.arity);
+    //    entryNode.Attributes.Append(arityAttribute);
+    //    foreach (object o in f.localData) {
+    //      if (f.localData.Count > 0) {
+    //        entryNode.AppendChild(CreateDataNode(document, o));
+    //      }
+    //    }
+    //    linearRepresentationNode.AppendChild(entryNode);
+    //  }
+
+    //  node.AppendChild(linearRepresentationNode);
+    //  return node;
+    //}
+
+    private XmlNode CreateDataNode(XmlDocument doc, object o) {
+      XmlNode node = doc.CreateElement("Data");
+      XmlAttribute typeAttr = doc.CreateAttribute("Type");
+      node.Attributes.Append(typeAttr);
+      if (o is double) {
+        node.Value = XmlConvert.ToString((double)o);
+        typeAttr.Value = "d";
+      } else if (o is int) {
+        node.Value = XmlConvert.ToString((int)o);
+        typeAttr.Value = "i";
+      } else if (o is string) {
+        node.Value = (string)o;
+        typeAttr.Value = "s";
+      } else throw new ArgumentException("Invalid type for local data element: " + o);
+      return node;
+    }
+
+    //public override void Populate(XmlNode node, IDictionary<Guid, IStorable> restoredObjects) {
+    //  base.Populate(node, restoredObjects);
+    //  XmlNode linearRepresentationNode = node.SelectSingleNode("LinearRepresentation");
+    //  foreach (XmlNode entryNode in linearRepresentationNode.ChildNodes) {
+    //    LightWeightFunction f = new LightWeightFunction();
+    //    f.arity = XmlConvert.ToByte(entryNode.Attributes["Arity"].Value);
+    //    foreach (XmlNode dataNode in entryNode.ChildNodes) {
+    //      f.localData.Add(ParseDataNode(dataNode));
+    //    }
+    //    f.functionType = (IFunction)PersistenceManager.Restore(entryNode, restoredObjects);
+    //    linearRepresentation.Add(f);
+    //  }
+    //  treesExpanded = false;
+    //  variablesExpanded = false;
+    //}
+
+    private object ParseDataNode(XmlNode dataNode) {
+      string type = dataNode.Attributes["Type"].Value;
+      if (type == "d") {
+        return XmlConvert.ToDouble(dataNode.Value);
+      } else if (type == "i") {
+        return XmlConvert.ToInt32(dataNode.Value);
+      } else if (type == "s") {
+        return dataNode.Value;
+      } else throw new FormatException("Can't parse type \"" + type + "\" \"" + dataNode.Value + "\" as local data for GP trees");
+    }
+
+    //private string GetString(IEnumerable<double> xs) {
+    //  StringBuilder builder = new StringBuilder();
+    //  foreach (double x in xs) {
+    //    builder.Append(x.ToString("r", CultureInfo.InvariantCulture) + "; ");
+    //  }
+    //  if (builder.Length > 0) builder.Remove(builder.Length - 2, 2);
+    //  return builder.ToString();
+    //}
+
+    //private List<T> GetList<T>(string s, Converter<string, T> converter) {
+    //  List<T> result = new List<T>();
+    //  string[] tokens = s.Split(new char[] { ';', ' ' }, StringSplitOptions.RemoveEmptyEntries);
+    //  foreach (string token in tokens) {
+    //    T x = converter(token.Trim());
+    //    result.Add(x);
+    //  }
+    //  return result;
+    //}
+
+    public override object Clone(IDictionary<Guid, object> clonedObjects) {
+      BakedFunctionTree clone = new BakedFunctionTree();
+      // in case the user (de)serialized the tree between evaluation and selection we have to flatten the tree again.
+      if (treesExpanded) FlattenTrees();
+      if (variablesExpanded) FlattenVariables();
+      foreach (LightWeightFunction f in linearRepresentation) {
+        clone.linearRepresentation.Add(f.Clone());
+      }
+      return clone;
+    }
+
+    public override IView CreateView() {
+      return new FunctionTreeView(this);
+    }
+
+    //public override string ToString() {
+    //  SymbolicExpressionExporter exporter = new SymbolicExpressionExporter();
+    //  exporter.Visit(this);
+    //  return exporter.GetStringRepresentation();
+    //}
+  }
+}
Index: branches/GP-Refactoring-713/sources/HeuristicLab.GP/3.3/BaseClasses/BinaryFunction.cs
===================================================================
--- branches/GP-Refactoring-713/sources/HeuristicLab.GP/3.3/BaseClasses/BinaryFunction.cs	(revision 2210)
+++ branches/GP-Refactoring-713/sources/HeuristicLab.GP/3.3/BaseClasses/BinaryFunction.cs	(revision 2210)
@@ -0,0 +1,35 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Constraints;
+
+namespace HeuristicLab.GP {
+  public abstract class BinaryFunction : FunctionBase {
+    public BinaryFunction()
+      : base() {
+      MinArity = 2; MaxArity = 2;
+    }
+  }
+}
Index: branches/GP-Refactoring-713/sources/HeuristicLab.GP/3.3/BaseClasses/FunctionBase.cs
===================================================================
--- branches/GP-Refactoring-713/sources/HeuristicLab.GP/3.3/BaseClasses/FunctionBase.cs	(revision 2210)
+++ branches/GP-Refactoring-713/sources/HeuristicLab.GP/3.3/BaseClasses/FunctionBase.cs	(revision 2210)
@@ -0,0 +1,214 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Text;
+using HeuristicLab.Data;
+using HeuristicLab.Core;
+using System.Xml;
+using HeuristicLab.Constraints;
+using System.Diagnostics;
+using HeuristicLab.GP.Interfaces;
+
+namespace HeuristicLab.GP {
+  public abstract class FunctionBase : ItemBase, IFunction {
+    private List<List<IFunction>> allowedSubFunctions = new List<List<IFunction>>();
+    private int minArity = -1;
+    private int maxArity = -1;
+    private double tickets = 1.0;
+    private IOperator initializer;
+    private IOperator manipulator;
+    private int minTreeHeight = -1;
+    private int minTreeSize = -1;
+
+    public virtual string Name {
+      get { return this.GetType().Name; }
+    }
+
+    public virtual string Description {
+      get { return "Description for this function is missing (TODO)"; }
+    }
+
+    public int MinArity {
+      get {
+        return minArity;
+      }
+      protected set {
+        minArity = value;
+        while (minArity > allowedSubFunctions.Count) allowedSubFunctions.Add(new List<IFunction>());
+      }
+    }
+
+    public int MaxArity {
+      get {
+        return maxArity;
+      }
+      protected set {
+        maxArity = value;
+        while (allowedSubFunctions.Count > maxArity) allowedSubFunctions.RemoveAt(allowedSubFunctions.Count - 1);
+        while (maxArity > allowedSubFunctions.Count) allowedSubFunctions.Add(new List<IFunction>());
+      }
+    }
+
+
+    public int MinTreeSize {
+      get {
+        if (minTreeSize <= 0) RecalculateMinimalTreeSize();
+        return minTreeSize;
+      }
+    }
+
+    public int MinTreeHeight {
+      get {
+        if (minTreeHeight <= 0) RecalculateMinimalTreeHeight();
+        return minTreeHeight;
+      }
+    }
+
+    public double Tickets {
+      get { return tickets; }
+      set {
+        if (value < 0.0) throw new ArgumentException("Number of tickets must be positive");
+        else tickets = value;
+      }
+    }
+
+    public IOperator Initializer {
+      get { return initializer; }
+      set { initializer = value; }
+    }
+
+    public IOperator Manipulator {
+      get { return manipulator; }
+      set { manipulator = value; }
+    }
+
+    public virtual IEnumerable<string> LocalParameterNames {
+      get { return new string[0]; }
+    }
+
+    public virtual IFunctionTree GetTreeNode() {
+      return new FunctionTreeBase(this);
+    }
+
+    //private List<IConstraint> constraints = new List<IConstraint>();
+    //public ICollection<IConstraint> Constraints {
+    //  get { return constraints; }
+    //}
+
+    //private void RefreshArity() {
+    //  minArity = 2; maxArity = 2; // default arity is 2
+    //  foreach (IConstraint constraint in Constraints) {
+    //    NumberOfSubOperatorsConstraint theConstraint = constraint as NumberOfSubOperatorsConstraint;
+    //    if (theConstraint != null) {
+    //      minArity = theConstraint.MinOperators.Data;
+    //      maxArity = theConstraint.MaxOperators.Data;
+    //    }
+    //  }
+    //}
+
+    public ICollection<IFunction> GetAllowedSubFunctions(int index) {
+      if (index < 0 || index > MaxArity) throw new ArgumentException("Index outside of allowed range. index = " + index);
+      //if (allowedSubFunctions == null) {
+      //  // first time: analyze the constraint and create a cached copy of the allowed sub-functions
+      //  allowedSubFunctions = new List<IFunction>[MaxArity];
+      //  for (int i = 0; i < MaxArity; i++) {
+      //    allowedSubFunctions[i] = GetAllowedSubFunctions(i);
+      //  }
+      //}
+      return allowedSubFunctions[index];
+    }
+
+    public void AddAllowedSubFunction(IFunction function, int index) {
+      if (index < 0 || index > MaxArity) throw new ArgumentException("Index outside of allowed range. index = " + index);
+      if (allowedSubFunctions[index] == null) {
+        allowedSubFunctions[index] = new List<IFunction>();
+      }
+      if (!allowedSubFunctions[index].Contains(function)) {
+        allowedSubFunctions[index].Add(function);
+      }
+    }
+
+    public void RemoveAllowedSubFunction(IFunction function, int index) {
+      if (index < 0 || index > MaxArity) throw new ArgumentException("Index outside of allowed range. index = " + index);
+      allowedSubFunctions[index].Add(function);
+    }
+
+    public bool IsAllowedSubFunction(IFunction function, int index) {
+      return GetAllowedSubFunctions(index).Contains(function);
+    }
+
+    //private List<IFunction> GetAllowedSubFunctions(int index) {
+    //  List<IFunction> allowedSubFunctions = new List<IFunction>();
+    //  foreach (IConstraint constraint in Constraints) {
+    //    if (constraint is SubOperatorTypeConstraint) {
+    //      SubOperatorTypeConstraint subOpConstraint = constraint as SubOperatorTypeConstraint;
+    //      if (subOpConstraint.SubOperatorIndex.Data == index) {
+    //        foreach (IFunction f in subOpConstraint.AllowedSubOperators) allowedSubFunctions.Add(f);
+    //        subOpConstraint.Changed += new EventHandler(subOpConstraint_Changed); // register an event-handler to invalidate the cache on constraint changes
+    //        return allowedSubFunctions;
+    //      }
+    //    } else if (constraint is AllSubOperatorsTypeConstraint) {
+    //      AllSubOperatorsTypeConstraint subOpConstraint = constraint as AllSubOperatorsTypeConstraint;
+    //      foreach (IFunction f in subOpConstraint.AllowedSubOperators) allowedSubFunctions.Add(f);
+    //      subOpConstraint.Changed += new EventHandler(subOpConstraint_Changed); // register an event-handler to invalidate the cache on constraint changes
+    //      return allowedSubFunctions;
+    //    }
+    //  }
+    //  return allowedSubFunctions;
+    //}
+
+    //private void subOpConstraint_Changed(object sender, EventArgs e) {
+    //  allowedSubFunctions = null;
+    //}
+
+    public override IView CreateView() {
+      return new FunView(this);
+    }
+
+    private void RecalculateMinimalTreeSize() {
+      minTreeSize = int.MaxValue;
+      int sum = 1;
+      int minSize = int.MaxValue;
+      for (int i = 0; i < MinArity; i++) {
+        foreach (IFunction subFun in GetAllowedSubFunctions(i)) {
+          minSize = Math.Min(minSize, subFun.MinTreeSize);
+        }
+        sum += minSize;
+      }
+      minTreeSize = sum;
+    }
+
+    private void RecalculateMinimalTreeHeight() {
+      minTreeHeight = int.MaxValue;
+      int height = 0;
+      int minHeight = int.MaxValue;
+      for (int i = 0; i < MinArity; i++) {
+        foreach (IFunction subFun in GetAllowedSubFunctions(i)) {
+          minHeight = Math.Min(minHeight, subFun.MinTreeHeight);
+        }
+        height = Math.Max(height, minHeight);
+      }
+      minTreeHeight = height + 1;
+    }
+  }
+}
Index: branches/GP-Refactoring-713/sources/HeuristicLab.GP/3.3/BaseClasses/FunctionTreeBase.cs
===================================================================
--- branches/GP-Refactoring-713/sources/HeuristicLab.GP/3.3/BaseClasses/FunctionTreeBase.cs	(revision 2210)
+++ branches/GP-Refactoring-713/sources/HeuristicLab.GP/3.3/BaseClasses/FunctionTreeBase.cs	(revision 2210)
@@ -0,0 +1,97 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Text;
+using HeuristicLab.Core;
+using HeuristicLab.GP.Interfaces;
+
+namespace HeuristicLab.GP {
+  public class FunctionTreeBase : IFunctionTree {
+    private List<IFunctionTree> subTrees;
+    private IFunction function;
+
+    public FunctionTreeBase(IFunction function) {
+      subTrees = new List<IFunctionTree>();
+      this.function = function;
+    }
+
+    protected FunctionTreeBase(FunctionTreeBase original) {
+      this.function = original.Function;
+      this.subTrees = new List<IFunctionTree>(original.SubTrees.Count);
+      foreach (IFunctionTree originalSubTree in original.SubTrees) {
+        this.SubTrees.Add(originalSubTree.Clone());
+      }
+    }
+
+    #region IFunctionTree Members
+    public virtual bool HasLocalParameters {
+      get { return false; }
+    }
+
+    public IList<IFunctionTree> SubTrees {
+      get { return subTrees; }
+    }
+
+    public IFunction Function {
+      get { return function; }
+    }
+
+    public int GetSize() {
+      int size = 1;
+      foreach (IFunctionTree tree in subTrees) size += tree.GetSize();
+      return size;
+    }
+
+    public int GetHeight() {
+      int maxHeight = 0;
+      foreach (IFunctionTree tree in subTrees) maxHeight = Math.Max(maxHeight, tree.GetHeight());
+      return maxHeight + 1;
+    }
+
+    public virtual IOperation CreateShakingOperation(IScope scope) {
+      return null;
+    }
+
+    public virtual IOperation CreateInitOperation(IScope scope) {
+      return null;
+    }
+
+    public void AddSubTree(IFunctionTree tree) {
+      subTrees.Add(tree);
+    }
+
+    public void InsertSubTree(int index, IFunctionTree tree) {
+      subTrees.Insert(index, tree);
+    }
+
+    public void RemoveSubTree(int index) {
+      subTrees.RemoveAt(index);
+    }
+
+    public virtual IFunctionTree Clone() {
+      return new FunctionTreeBase(this);
+    }
+
+    #endregion
+  }
+}
